#include "hmg.ch"

Function main()

EnableDragAndDrop()

	DEFINE WINDOW Form_1 ;
		AT 0,0 ;
		WIDTH 700 ;
		HEIGHT 500 ;
		TITLE 'TreeView Simple Sample Drag And Drop' ;
		MAIN 

		@ 10,50 LABEL Label_1 VALUE "You can drag nodes and items in the same tree or from Tree #1 to Tree #2." AUTOSIZE
		
		@ 30,10 LABEL Label_2 VALUE "Tree #1." AUTOSIZE
	
		DEFINE TREE Tree_1 AT 50,10 WIDTH 200 HEIGHT 400 VALUE 15 ON GOTFOCUS Drag_Tree1() ON CHANGE Form_1.Title:='Tree #1, Item # '+hb_valtostr(Form_1.tree_1.Value)

			NODE 'Item 1' 
				TREEITEM 'Item 1.1'
				TREEITEM 'Item 1.2'
				TREEITEM 'Item 1.3'
			END NODE

			NODE 'Item 2'

				TREEITEM 'Item 2.1'

				NODE 'Item 2.2'
					TREEITEM 'Item 2.2.1'
					TREEITEM 'Item 2.2.2'
					TREEITEM 'Item 2.2.3'
					TREEITEM 'Item 2.2.4'
					TREEITEM 'Item 2.2.5'
					TREEITEM 'Item 2.2.6'
					TREEITEM 'Item 2.2.7'
					TREEITEM 'Item 2.2.8'
				END NODE

				TREEITEM 'Item 2.3'

			END NODE

			NODE 'Item 3'
				NODE 'Item 3.1'
					TREEITEM 'Item 3.1.1'
					NODE 'Item 3.1.2'
						TREEITEM 'Item 3.1.2.1'
						TREEITEM 'Item 3.1.2.2'
					END NODE
					TREEITEM 'Item 3.1.3'
				END NODE				
				
				TREEITEM 'Item 3.2'

				NODE 'Item 3.3'
					TREEITEM 'Item 3.3.1'
					TREEITEM 'Item 3.3.2'
				END NODE

			END NODE

		END TREE

	    @ 30,250 LABEL Label_3 VALUE "Tree #2." AUTOSIZE
		
	    DEFINE TREE Tree_2;
         AT 50,250; 
         WIDTH 250; 
         HEIGHT 400; 
         VALUE 1; 
         FONT "Calibri" SIZE 11;
         ON GOTFOCUS Drag_Tree2();
         ON CHANGE Form_1.Title:='Tree #2, Item # '+hb_valtostr(Form_1.tree_2.Value) ;
         NODEIMAGES { "folder.gif", "folder_page.gif" }; 
         ITEMIMAGES { "Page.gif",   "page_next.gif"   }; 
         NOROOTBUTTON 
         
         NODE 'MY APP '
            
            NODE 'BOOK      [F1]'
               TREEITEM 'Science'
               TREEITEM 'Literature' 
            END NODE
            
            NODE 'MUSIC     [F2]'
               TREEITEM 'Rock' 
               TREEITEM 'Classic'
            END NODE
            
            NODE 'VIDEOS    [F3]'
               TREEITEM 'Documentary' 
               TREEITEM 'Series'
               TREEITEM 'Sports'
            END NODE
            
            NODE 'EMAIL     [F4]'
               TREEITEM 'Send' 
               TREEITEM 'Inbox' 
               TREEITEM 'Outbox' 
               TREEITEM 'Drafts'
               TREEITEM 'Spam'
               TREEITEM 'Sent Items'
               NODE 'OTHER'
                  TREEITEM 'Backup'
                  TREEITEM 'Calendar'
               END NODE
            END NODE
            
            NODE 'ABOUT...  [F5]'
            END NODE
            
         END NODE
      END TREE

      Form_1.Tree_2.Expand (1)
      Form_1.Tree_2.FontSize := 12 // The control must have a size greater than or equal to font size of DynamicFont so that the text does not appear cut
      Form_1.Tree_2.DynamicFont      := {|| TreeFont() }
      Form_1.Tree_2.DynamicBackColor := {|| IF (This.TreeItemValue == Form_1.Tree_2.Value, WHITE, NIL ) }
      Form_1.Tree_2.DynamicForeColor := {|| IF (This.TreeItemValue == Form_1.Tree_2.Value, BLUE,  NIL ) }

      @ 50, 520 TEXTBOX Text_1 HEIGHT 24 WIDTH  120 VALUE "" ON GOTFOCUS drag_Text_1()
 
      CREATE EVENT PROCNAME Tree_2_RCLICK() HWND Form_1.Tree_2.HANDLE STOREINDEX nIndex


	END WINDOW

	ACTIVATE WINDOW Form_1

Return

********************************************************************
FUNCTION Tree_2_RCLICK()
LOCAL nHWnd := EventHWND(), aResults
LOCAL nhItemMouseOver := TREEVIEW_HITTEST( nHWnd, GetCursorRow() - GetWindowRow ( nHWnd ), GetCursorCol() - GetWindowCol ( nHWnd ) )
LOCAL nTreeId, cItem
STATIC nTV := -1

IF nhItemMouseOver # nTV
	nTV := nhItemMouseOver
	IF IsControlContextMenuDefined( 'Tree_2', 'Form_1' )
		ReleaseControlContextMenu( 'Tree_2', 'Form_1' )
	ENDIF
	IF nTV > 0
		nTreeId := _GetTreeItemValue ( 'Tree_2', 'Form_1', nTV)
		cItem := Form_1.Tree_2.Item( nTreeId )
		DEFINE CONTROL CONTEXTMENU Tree_2 OF Form_1
			ITEM "Rename " + cItem ;
				ACTION { || ( aResults := InputWindow ( "Rename Item " + cItem, {'New item value:'}, { cItem }, {20}) , IF( aResults[1] # Nil, Form_1.Tree_2.Item( nTreeId ) := aResults[1] , Nil )) } ;
				IMAGE "edit.png"
			ITEM "Delete " + cItem ;
				ACTION { || ( Form_1.Tree_2.DeleteItem( nTreeId ), Form_1.Tree_2.SetDefaultAllNodeFlag, Form_1.Tree_2.Redraw ) } ;
				IMAGE "delete.png"
			SEPARATOR
			ITEM "Add New Item As Child" ;
				ACTION { || ( aResults := InputWindow ( "Add New Item", {'New item value:'}, { "" }, {20}) , IF( aResults[1] # Nil, Form_1.Tree_2.AddItem(aResults[1], nTreeId) , Nil ), Form_1.Tree_2.SetDefaultAllNodeFlag, Form_1.Tree_2.Redraw ) } ;
				IMAGE "add.png"
		END MENU
	ELSE
		DEFINE CONTROL CONTEXTMENU Tree_2 OF Form_1
			ITEM "Add New Item As Root" ;
				ACTION { || ( aResults := InputWindow ( "Add New Item", {'New item value:'}, { "" }, {20}) , IF( aResults[1] # Nil, Form_1.Tree_2.AddItem(aResults[1], 0) , Nil ), Form_1.Tree_2.SetDefaultAllNodeFlag, Form_1.Tree_2.Redraw ) } ;
				IMAGE "add.png"
		END MENU
	ENDIF
ENDIF

RETURN Nil


***********************************
Function Drag_Tree1()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()
Local nDragTreeValue := HMG_DaD_DragTreeValue()
Local nDropTreeValue := HMG_DaD_DropTreeValue()
Local lIsDraggedWithRightButton := HMG_Is_RButtonDaD()
Local lIsDraggedWithShiftButton := HMG_Is_ShiftDaD()

IF HMG_Is_DaD()
	HMG_Release_DaD()
	DO CASE
		CASE cDragFName == cDropFName .AND. cDragFName == 'Form_1' .AND. cDragCName == cDropCName .AND. cDragCName == 'Tree_1' .AND. nDragTreeValue <> nDropTreeValue
			Tree_2_UpDate ( cDragFName, cDragCName, nDragTreeValue, cDropCName, cDropFName, nDropTreeValue, HMG_VirtualKeyIsPressed (VK_LCONTROL) .OR. HMG_VirtualKeyIsPressed (VK_RCONTROL), !lIsDraggedWithShiftButton )
			
		ENDCASE
ENDIF

RETURN

*****************************************
Function Drag_Tree2()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local cDropFName := HMG_DaD_Drop_Window()
Local cDropCName := HMG_DaD_Drop_Control()
Local nDragTreeValue := HMG_DaD_DragTreeValue()
Local nDropTreeValue := HMG_DaD_DropTreeValue()
Local lIsDraggedWithRightButton := HMG_Is_RButtonDaD()
Local lIsDraggedWithShiftButton := HMG_Is_ShiftDaD()
Local TEXTBOXVal := HMG_DaD_CellValue()

IF HMG_Is_DaD()
	HMG_Release_DaD()
	DO CASE
		CASE cDragCName == 'Tree_1' .OR. cDragCName == 'Tree_2'
		
			IF cDragFName == cDropFName .AND. cDragCName == cDropCName .AND. nDragTreeValue = nDropTreeValue
				//we do not want to be able to drag and drop the item on itself
				RETURN Nil
			ENDIF
			
			IF lIsDraggedWithRightButton
				
				IF IsControlContextMenuDefined( 'Tree_2', 'Form_1' )
					ReleaseControlContextMenu( 'Tree_2', 'Form_1' )
				ENDIF

				DEFINE CONTROL CONTEXTMENU Tree_2 OF Form_1
					ITEM "Copy" ;
						ACTION { || ( Tree_2_UpDate ( cDragFName, cDragCName, nDragTreeValue, cDropCName, cDropFName, nDropTreeValue, .T., !lIsDraggedWithShiftButton ) ) } ;
						IMAGE "copy.png"
					ITEM "Move" ;
						ACTION { || ( Tree_2_UpDate ( cDragFName, cDragCName, nDragTreeValue, cDropCName, cDropFName, nDropTreeValue, .F., !lIsDraggedWithShiftButton ) ) } ;
						IMAGE "move.png"
				END MENU
			ELSE
				Tree_2_UpDate ( cDragFName, cDragCName, nDragTreeValue, cDropCName, cDropFName, nDropTreeValue, HMG_VirtualKeyIsPressed (VK_LCONTROL) .OR. HMG_VirtualKeyIsPressed (VK_RCONTROL), !lIsDraggedWithShiftButton )
			ENDIF
			
		CASE cDragCName == 'Text_1' .AND. !EMPTY( TEXTBOXVal )
			IF IsControlContextMenuDefined( 'Tree_2', 'Form_1' )
				ReleaseControlContextMenu( 'Tree_2', 'Form_1' )
			ENDIF
			DoMethod (cDropFName, cDropCName, "AddItem", TEXTBOXVal , nDropTreeValue )
			DoMethod (cDropFName, cDropCName, "Redraw")
	ENDCASE
ENDIF

RETURN

*************************************************************************

FUNCTION Tree_2_UpDate ( cDragFName, cDragCName, nDragTreeValue, cDropCName, cDropFName, nDropTreeValue, lCopy, lAdd )
Local aDragItems := _GetTreeItemStru( cDragFName, cDragCName, nDragTreeValue )
Local nAddPos

IF nDropTreeValue == 0 .AND. !MsgYesNo("Do you want to add an item as Root?", "Dropped in an empty area.", .T.)
	RETURN Nil
ENDIF

IF !EMPTY ( aDragItems )
	IF !lCopy .AND. nDropTreeValue < nDragTreeValue		//dropped above the drag
		DoMethod (cDragFName, cDragCName, "DeleteItem", nDragTreeValue)
	ENDIF

	nAddPos := nDropTreeValue
	IF lAdd		//add item
		AEVAL ( aDragItems, { |x| ( DoMethod (cDropFName, cDropCName, "AddItem", x[2] , nAddPos + x[3] ),  IF( x[3]=0 /* 1-st item added as last nodes item */, nAddPos := nAddPos + LEN( _GetTreeItemStru( cDropFName, cDropCName, nDropTreeValue ) ) - 1 - x [1] , Nil) ) } )
	ELSE			//insert
		nAddPos := _InsertItem ( cDropCName, cDropFName, aDragItems[1][2] , nDropTreeValue )
		nAddPos -= aDragItems[1][1]
		hb_ADel( aDragItems, 1, .T. )
		AEVAL ( aDragItems, { |x| DoMethod (cDropFName, cDropCName, "AddItem", x[2] , nAddPos + x[3] ) } )
	ENDIF
		
	IF !lCopy .AND. nDropTreeValue > nDragTreeValue		//dropped below the drag
		DoMethod (cDragFName, cDragCName, "DeleteItem", nDragTreeValue)
	ENDIF

	DoMethod (cDropFName, cDropCName, "SetDefaultAllNodeFlag")
				
	DoMethod (cDropFName, cDropCName, "Redraw")
	DoMethod (cDragFName, cDragCName, "Redraw")		
		
ENDIF
RETURN 
**************************************************************************
FUNCTION drag_Text_1()
Local cDragFName := HMG_DaD_Drag_Window()
Local cDragCName := HMG_DaD_Drag_Control()
Local nDragTreeValue := HMG_DaD_DragTreeValue()

IF HMG_Is_DaD()
	HMG_Release_DaD()
	
	DO CASE
		CASE cDragCName == 'Tree_1' .OR. cDragCName == 'Tree_2'
			This.Value := GetProperty(cDragFName, cDragCName, "Item", nDragTreeValue)
	ENDCASE
ENDIF

RETURN

*************************************************************************
Function TreeFont
LOCAL aFont
   IF Form_1.Tree_2.NodeFlag (This.TreeItemValue) == .T.   // for default: True Node always has the NodeFlag() == .T.
      aFont := ARRAY FONT "Calibri" SIZE 12 BOLD
   ELSE
      aFont := ARRAY FONT "Calibri" SIZE 11
   ENDIF
Return aFont



*************************************************
FUNCTION _GetTreeItemStru( cFormName, cTreeName, nTreeValue )
Local aTreeStru := {}, aChild
Local nParent := 0, nItem := 1
IF nTreeValue > 0 .AND. IsControlDefined ( &cTreeName, &cFormName )
	AADD (aTreeStru, { nTreeValue, GetProperty (cFormName, cTreeName, "Item", nTreeValue), nParent } )
	Do While nItem <= LEN ( aTreeStru )
		nParent := aTreeStru [nItem] [1]
		aChild := GetProperty ( cFormName, cTreeName, "ChildValue", nParent )
		nItem ++
		IF hb_isArray ( aChild )
			AEVAL (aChild, { |x| AADD( aTreeStru, { x, GetProperty (cFormName, cTreeName, "Item", x), nParent } ) } )
		ENDIF
	EndDo
ENDIF

ASORT ( aTreeStru, , , { |x, y| x[1] < y[1] } )

//*** Structure of aTreeStru***************
//* { { nItem, cItemText, nParentItem } , ... }
//*****************************************

Return aTreeStru